{
TGMBase class

  ES: Clase base para todos los componentes de la librera Google Maps Library
  EN: Base class for all components from library Google Maps Library

=========================================================================
History:

ver 0.1:
  ES: primera versin
  EN: first version
=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2011, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit GMBase;

interface

uses
  Classes,
  GMConstants, UAboutFrm;

type
  TGMBase = class(TComponent)
  private
    FAboutGMLib: TAboutFrm;
    FLanguage: TLang;
  protected
    function GetAPIUrl: string; virtual;
    procedure SetLanguage(const Value: TLang); virtual;
    function ControlPrecision(Value: Real; Prec: Integer{ = 6}): Real; virtual;
  public
    constructor Create(AOwner: TComponent); override;

    procedure Assign(Source: TPersistent); override;
  published
    // url a la pgina de la API de Google Maps
    // url to API Google Maps page
    property APIUrl: string read GetAPIUrl;
    // idioma de los mensajes y textos
    // language of messages and texts
    property Language: TLang read FLanguage write SetLanguage;
    // "Realizado por" de los componentes
    // "About box" of the components
    property AboutGMLib: TAboutFrm read FAboutGMLib stored False;
  end;

implementation

uses
  SysUtils, Math;

{ TGMBase }

procedure TGMBase.Assign(Source: TPersistent);
begin
  if Source is TGMBase then
  begin
    Language := TGMBase(Source).Language;
    AboutGMLib.Assign(TGMBase(Source).FAboutGMLib);
  end
  else
    inherited Assign(Source);
end;

function TGMBase.ControlPrecision(Value: Real; Prec: Integer): Real;
begin
  Result := Value;

  if Prec > 0 then
    Result := RoundTo(Result, (-1) * Prec);
end;

constructor TGMBase.Create(AOwner: TComponent);
begin
  inherited;

  Language := Espanol;
end;

function TGMBase.GetAPIUrl: string;
begin
  Result := 'https://developers.google.com/maps/documentation/javascript/reference?hl=en';
end;

procedure TGMBase.SetLanguage(const Value: TLang);
begin
  FLanguage := Value;
end;

end.
